updates, especially for etiona
[distro-setup] / distro-end
index 61008fa66a44452ab84279cb2936e83463b586d0..0c6b463623c5f9a352be268363910b0a73a5d5bd 100755 (executable)
@@ -1,6 +1,7 @@
-#!/bin/bash -l
+#!/bin/bash
 # Copyright (C) 2019 Ian Kelling
 # SPDX-License-Identifier: AGPL-3.0-or-later
+export BRC=t; if [[ -s ~/.bashrc ]];then . ~/.bashrc;fi
 
 ### setup
 source /a/bin/errhandle/err
@@ -11,16 +12,14 @@ if [[ $EUID == 0 ]]; then
   exit 1
 fi
 
-_errcatch_cleanup() {
+err-cleanup() {
   echo 1 >~/.local/distro-end
 }
 
 # shellcheck source=./pkgs
 source $src/pkgs
 
-set -x
-exec &> >(sudo tee -a /var/log/distro-end)
-echo "$0: $(date): starting now)"
+echo "$0: $(date) starting now)"
 # see example of usage to understand.
 end_msg() {
   local y
@@ -32,26 +31,33 @@ end() {
   echo 0 >~/.local/distro-end
   if $pending_reboot; then
     echo "$0: pending reboot and then finished. doing it now."
-    s reboot now
+    echo "exiting with status 0"
+    sudo reboot now
   else
     echo "$0: $(date): ending now)"
+    echo "exiting with status 0"
   fi
   exit 0
 }
-die() {
-  printf "$0: %s\n" "$*" >&2; exit 1
+pre="${0##*/}:"
+sudo() {
+  printf "$pre %s\n"  "$*"
+  SUDOD="$PWD" command sudo "$@";
 }
-spa() { # simple package add
-  simple_packages+=($@)
+sd() {
+  sudo dd of="$1" 2>/dev/null
 }
+m() { printf "$pre %s\n"  "$*"; "$@"; }
+e() { printf "$pre %s\n"  "$*"; }
+err() { echo "[$(date +'%Y-%m-%d %H:%M:%S%z')]: $0: $*" >&2; }
 distro=$(distro-name)
 codename=$(debian-codename)
 codename_compat=$(debian-codename-compat)
 pending_reboot=false
 sed="sed --follow-symlinks"
-# template
-case $distro in
-esac
+## template:
+case $distro in
+esac
 
 #### initial packages
 pup
@@ -60,7 +66,7 @@ if isdeb; then
 fi
 
 # avoid prompts
-s debconf-set-selections <<EOF
+sudo debconf-set-selections <<EOF
 popularity-contest popularity-contest/participate boolean true
 EOF
 
@@ -70,12 +76,11 @@ pi ${p2[@]}
 
 conflink
 
-
 # no equivalent in other distros:
 if isdeb && pcheck apt-file; then
   # this condition is just a speed optimization
   pi apt-file
-  s apt-file update
+  sudo apt-file update
 fi
 
 
@@ -87,12 +92,12 @@ case $distro in
     # i'd rather disable the service than comment the init file
     # this says disabling the service, it will still get restarted
     # but this script doesn't do anything on restart, so it should be fine
-    s dd of=/var/run/motd.dynamic if=/dev/null
+    sudo truncate -s0 /var/run/motd.dynamic
     ;;
   trisquel|ubuntu)
     # this isn't a complete solution. It still shows me when updates are available,
     # but it's no big deal.
-    s rm -f /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
+    sudo rm -fv /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
     ;;
 esac
 
@@ -100,28 +105,28 @@ esac
 
 
 ### begin certbot install ###
-if [[ $distro == debian ]]; then
+if [[ $distro == debian || $codename_compat == bionic ]]; then
   # note, need python-certbot-nginx for nginx, but it depends on nginx,
   # and I'm not installing nginx by default right now.
-  pi certbot python-certbot-apache
+  pi certbot python3-certbot-apache
 elif [[ $codename_compat == xenial ]]; then
   # not packaged in xenial or flidas
   pi software-properties-common
   l="deb http://ppa.launchpad.net/certbot/certbot/ubuntu xenial main"
   if ! grep -xFq "$l" /etc/apt/sources.list{,.d/*.list}; then
-    s add-apt-repository -y ppa:certbot/certbot ||:
-    p update
+    sudo add-apt-repository -y ppa:certbot/certbot ||:
+    p update
   fi
   pi python-certbot-apache
 else
-  die "distro unknown for certbot"
+  err "distro unknown for certbot"
 fi
 # make a version of the certbot timer that emails me.
 x=/systemd/system/certbot
-$sed -r -f - /lib$x.timer <<'EOF' |s dd of=/etc${x}mail.timer
+$sed -r -f - /lib$x.timer <<'EOF' |s/etc${x}mail.timer
 s,^Description.*,\0 mail version,
 EOF
-$sed -r -f - /lib$x.service <<'EOF' |s dd of=/etc${x}mail.service
+$sed -r -f - /lib$x.service <<'EOF' |s/etc${x}mail.service
 s,(ExecStart=)(/usr/bin/certbot),\1/a/bin/log-quiet/sysd-mail-once certbotmail \2 --renew-hook /a/bin/distro-setup/certbot-renew-hook,
 EOF
 ser daemon-reload
@@ -164,7 +169,7 @@ case $(debian-codename) in
   # needed for debootstrap scripts for fai since fai requires debian
   flidas)
     curl http://archive.ubuntu.com/ubuntu/project/ubuntu-archive-keyring.gpg | s apt-key add -
-    s dd of=/etc/apt/preferences.d/flidas-xenial <<EOF
+    s/etc/apt/preferences.d/flidas-xenial <<EOF
 Package: *
 Pin: release a=xenial
 Pin-Priority: -100
@@ -176,15 +181,20 @@ Pin-Priority: -100
 Package: *
 Pin: release a=xenial-security
 Pin-Priority: -100
+
+Package: firefox
+Pin: release n=xenial
+Pin-Priority: 500
 EOF
-    s dd of=/etc/apt/sources.list.d/xenial.list 2>/dev/null <<EOF
+    s/etc/apt/sources.list.d/xenial.list 2>/dev/null <<EOF
 deb http://us.archive.ubuntu.com/ubuntu/ xenial main
 deb http://us.archive.ubuntu.com/ubuntu/ xenial-updates main
 deb http://us.archive.ubuntu.com/ubuntu/ xenial-security main
 EOF
 
-    s apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 3B4FE6ACC0B21F32
-    s dd of=/etc/apt/preferences.d/flidas-bionic <<EOF
+    if ! apt-key list | grep /C0B21F32 &>/dev/null; then
+      sudo apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 3B4FE6ACC0B21F32
+      sd /etc/apt/preferences.d/flidas-bionic <<EOF
 Package: *
 Pin: release a=bionic
 Pin-Priority: -100
@@ -197,10 +207,11 @@ Package: *
 Pin: release a=bionic-security
 Pin-Priority: -100
 EOF
+    fi
 
     # better to run btrfs-progs which matches our kernel version
     # (note, renamed from btrfs-tools)
-    s dd of=/etc/apt/preferences.d/btrfs-progs <<EOF
+    s/etc/apt/preferences.d/btrfs-progs <<EOF
 Package: btrfs-progs libzstd1
 Pin: release a=bionic
 Pin-Priority: 1005
@@ -223,22 +234,24 @@ deb http://us.archive.ubuntu.com/ubuntu/ bionic-security main
 EOF
     f=/etc/apt/sources.list.d/bionic.list
     if ! diff -q $t $f; then
-      s cp $t $f
-      s chmod 644 $f
-      p update
+      sudo cp $t $f
+      sudo chmod 644 $f
+      p update
     fi
 
     # no special reason, but its better for btrfs-progs to
     # be closer to our kernel version
     pi btrfs-progs
 
-    t=$(mktemp -d)
-    cd $t
-    aptitude download debootstrap/xenial
-    ex ./*
-    s cp ./usr/share/debootstrap/scripts/* /usr/share/debootstrap/scripts
+    if [[ ! -e /usr/share/debootstrap/scripts/xenial ]]; then
+      t=$(mktemp -d)
+      cd $t
+      m aptitude download debootstrap/xenial
+      m ex ./*
+      sudo cp ./usr/share/debootstrap/scripts/* /usr/share/debootstrap/scripts
+    fi
 
-    s dd of=/etc/apt/preferences.d/flidas-etiona <<EOF
+    s/etc/apt/preferences.d/flidas-etiona <<EOF
 Package: *
 Pin: release a=etiona
 Pin-Priority: -100
@@ -265,19 +278,19 @@ deb http://mirror.fsf.org/trisquel/ etiona-backports main
 EOF
     f=/etc/apt/sources.list.d/etiona.list
     if ! diff -q $t $f; then
-      s cp $t $f
-      s chmod 644 $f
-      p update
+      sudo cp $t $f
+      s chmod 644 $f
+      p update
     fi
 
-    s dd of=/etc/apt/preferences.d/debian-goodies <<EOF
+    s/etc/apt/preferences.d/debian-goodies <<EOF
 Package: debian-goodies
 Pin: release n=etiona
 Pin-Priority: 1005
 EOF
 
 
-    s dd of=/etc/apt/preferences.d/flidas-buster <<EOF
+    s/etc/apt/preferences.d/flidas-buster <<EOF
 Package: *
 Pin: release n=buster
 Pin-Priority: -100
@@ -290,14 +303,14 @@ EOF
     # dont use buster because it causes dist-upgrade to think its downgrading
     # packages while really just reinstalling the same version.
     f=/etc/apt/apt.conf.d/01iank
-    s rm -f $f
+    sudo rm -fv $f
     #         # stupid buster uses some key algorithm not supported by flidas gpg that apt uses.
-    #         s dd of=/etc/apt/apt.conf.d/01iank <<'EOF'
+    #         s/etc/apt/apt.conf.d/01iank <<'EOF'
     # Acquire::AllowInsecureRepositories "true";
     # EOF
 
     f=/etc/apt/sources.list.d/buster.list
-    s rm -f $f
+    sudo rm -fv $f
     #         t=$(mktemp)
     #         cat >$t <<EOF
     # deb http://http.us.debian.org/debian buster main
@@ -318,9 +331,9 @@ EOF
     # newer version needed for false positive in checkrestart.
     # I did buster at first, but other problem above with having
     # buster repos. not sure if the false positive exists in etiona.
-    p install -y --allow-unauthenticated debian-goodies
+    pi debian-goodies
 
-    s dd of=/etc/apt/preferences.d/shellcheck <<EOF
+    s/etc/apt/preferences.d/shellcheck <<EOF
 Package: shellcheck
 Pin: release a=etiona
 Pin-Priority: 1005
@@ -334,7 +347,7 @@ Pin: release a=etiona-security
 Pin-Priority: 1005
 EOF
 
-    s dd of=/etc/apt/preferences.d/bash <<EOF
+    s/etc/apt/preferences.d/bash <<EOF
 Package: bash
 Pin: release a=etiona
 Pin-Priority: 1005
@@ -349,7 +362,18 @@ Pin-Priority: 1005
 EOF
 
 
-    ;;
+    ;;&
+  etiona)
+    sd /etc/apt/preferences.d/etiona-bionic <<'EOF'
+Package: *
+Pin: release n=bionic
+Pin-Priority: -100
+
+Package: firefox gnome-screenshot gnome-icon-theme libnautilus-extension1a gnome-settings-daemon nautilus yelp gnome-settings-daemon-schemas nautilus-data ubuntu-wallpapers gnome-control-center gnome-control-center-data gnome-control-center-faces libsnapd-glib1 ubuntu-wallpapers-bionic gir1.2-snapd-1 ubuntu-drivers-common ubuntu-docs libyelp0
+Pin: release n=bionic
+Pin-Priority: 500
+EOF
+    ;;&
   *)
     if isdeb; then
       pi debian-goodies shellcheck
@@ -359,7 +383,7 @@ esac
 ######### end flidas pinned packages ######
 
 ##### begin automatic upgrades (after checkrestart has been installed) ####
-s dd of=/etc/apt/apt.conf.d/10periodic <<'EOF'
+s/etc/apt/apt.conf.d/10periodic <<'EOF'
 # this file was mostly just comments.
 APT::Periodic::Update-Package-Lists "1";
 APT::Periodic::Download-Upgradeable-Packages "1";
@@ -367,7 +391,7 @@ APT::Periodic::AutocleanInterval "7";
 APT::Periodic::Unattended-Upgrade "1";
 EOF
 
-s dd of=/etc/apt/apt.conf.d/50unattended-upgrades  <<EOF
+s/etc/apt/apt.conf.d/50unattended-upgrades  <<EOF
 # fyi: default file has comments about available options,
 # you may want to read that, do pkx unattended-upgrades
 Unattended-Upgrade::Mail "root";
@@ -375,19 +399,24 @@ Unattended-Upgrade::MailOnlyOnError "true";
 Unattended-Upgrade::Remove-Unused-Dependencies "true";
 Unattended-Upgrade::Origins-Pattern {
   # default is just security updates. this list found from reading
-  # match_whitelist_string() in `which unattended-upgrades`
+  # match_whitelist_string() in $(which unattended-upgrades)
   "o=*,l=*,a=*,c=*,site=*,n=*";
 };
 EOF
 
 # old names, too verbose
-s rm -f /etc/cron.d/unattended-upgrade-reboot /usr/local/bin/zelous-unattended-reboot
+sudo rm -f /etc/cron.d/unattended-upgrade-reboot /usr/local/bin/zelous-unattended-reboot
 
-s dd of=/etc/cron.d/myupgrade <<'EOF'
+s/etc/cron.d/myupgrade <<'EOF'
 # Setup reboots when running outdated stuff, unattended upgrades happen
 # at 6 am + rand(60 min).
-20 7 * * * root /usr/local/bin/myupgrade | /usr/local/bin/log-once -1 myupgrade
-0 * * * * root /usr/local/bin/mycheckrestart | /usr/local/bin/log-once -1 mycheckrestart
+
+# default is /bin/sh
+SHELL=/bin/bash
+# default is /usr/bin:/bin
+PATH=/usr/bin:/bin:/usr/local/bin
+20 7 * * * iank myupgrade |& log-once -1 myupgrade
+0  * * * * root mycheckrestart |& log-once -1 mycheckrestart
 EOF
 ##### end automatic upgrades ####
 
@@ -396,35 +425,53 @@ EOF
 ###### begin website setup
 case $HOSTNAME in
   li|l2)
+    pi bind9
     f=/var/lib/bind/db.b8.nz
     if [[ ! -e $f ]]; then
       ser stop bind9
-      s rm -f $f.jnl
-      s install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
+      sudo rm -fv $f.jnl
+      sudo install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
       ser restart bind9
     fi
     ;;&
   l2)
+    # setup let's encrypt cert
+    m web-conf apache2 l2.b8.nz
+    sudo rm -fv /etc/apache2/sites-enabled/l2.b8.nz{,-redir}.conf
+    ser reload apache2
+    s lnf -T /etc/letsencrypt/live/l2.b8.nz/fullchain.pem /etc/exim4/exim.crt
+    if [[ ! -L /etc/exim4/exim.key ]]; then
+      s lnf -T /etc/letsencrypt/live/l2.b8.nz/privkey.pem /etc/exim4/exim.key
+      mail-setup
+    fi
     end
     ;;
   li)
 
     case $HOSTNAME in
-      li) domain=iankelling.org ;;
+      li)
+        m /a/h/setup.sh iankelling.org
+        ;;
+      tp)
+        m /a/h/setup.sh -s b8.nz
+        ;;
+      *)
+        # allow symlinks on non-main hosts so i can host files in arbitrary paths
+        m /a/h/setup.sh -s -p 80
+        ;;
     esac
-    /a/h/setup.sh $domain
-    /a/h/build.rb
+    m /a/h/build.rb
 
     # start mumble only when im going to use it, since i dont use it much
     pi-nostart mumble-server
-    s $sed -ri "s/^ *(serverpassword=).*/\1$(< /a/bin/bash_unpublished/mumble_pass)/" /etc/mumble-server.ini
+    sudo $sed -ri "s/^ *(serverpassword=).*/\1$(< /a/bin/bash_unpublished/mumble_pass)/" /etc/mumble-server.ini
 
     # do certificate to avoid warning about unsigned cert,
     # which is overkill for my use, but hey, I'm cool, I know
     # how to do this.
-    web-conf apache2 mumble.iankelling.org
-    s rm -f /etc/apache2/sites-enabled/mumble.iankelling.org
-    sudo -i <<'EOF'
+    web-conf apache2 mumble.iankelling.org
+    sudo rm -fv /etc/apache2/sites-enabled/mumble.iankelling.org
+    s <<'EOF'
 export RENEWED_LINEAGE=/etc/letsencrypt/live/mumble.iankelling.org
 /a/bin/distro-setup/certbot-renew-hook
 EOF
@@ -438,8 +485,8 @@ EOF
     # https://community.openvpn.net/openvpn/wiki/IPv6
     # and man openvpn
 
-    vpn-server-setup -rd 2600:3c00:e000:280::1/64 2600:3c00::f03c:91ff:feb4:0bf3
-    s tee /etc/openvpn/client-config/mail <<'EOF'
+    vpn-server-setup -rd 2600:3c00:e000:280::1/64 2600:3c00::f03c:91ff:feb4:0bf3
+    sudo tee /etc/openvpn/client-config/mail <<'EOF'
 ifconfig-push 10.8.0.4 255.255.255.0
 ifconfig-ipv6-push 2600:3c00:e000:280::2/64
 EOF
@@ -469,8 +516,8 @@ EOF
     tu /etc/hosts <<<"10.8.0.4 mail.iankelling.org"
     sgo $vpn_service
     # setup let's encrypt cert
-    web-conf apache2 mail.iankelling.org
-    s rm /etc/apache2/sites-enabled/mail.iankelling.org{,-redir}.conf
+    web-conf apache2 mail.iankelling.org
+    sudo rm -fv /etc/apache2/sites-enabled/mail.iankelling.org{,-redir}.conf
     ser reload apache2
 
     domain=cal.iankelling.org
@@ -500,7 +547,7 @@ EOF
     # to get into the web interface,
     # then use non-main browser or else it doebsn't allow it based on ocsp stapling from my main site.
     # https://iankelling.org:12533/
-    sudo -i <<'EOF'
+    s <<'EOF'
 export RENEWED_LINEAGE=/etc/letsencrypt/live/iankelling.org
 /a/bin/distro-setup/certbot-renew-hook
 EOF
@@ -538,23 +585,17 @@ EOF
     # https://wiki.znc.in/self-message
     # https://wiki.znc.in/Query_buffers                                                \
       #
-    s useradd --create-home -d /var/lib/znc --system --shell /sbin/nologin --comment "Account to run ZNC daemon" --user-group znc || [[ $? == 9 ]] # 9 if it exists already
-    s chmod 700 /var/lib/znc
-    s chown -R znc:znc /var/lib/znc
-    s dd of=/etc/systemd/system/znc.service 2>/dev/null <<'EOF'
-[Unit]
-Description=ZNC, an advanced IRC bouncer
-After=network-online.target
-
-[Service]
-ExecStart=/usr/bin/znc -f --datadir=/var/lib/znc
-User=znc
-
-[Install]
-WantedBy=multi-user.target
-EOF
-    ser daemon-reload
-    sgo znc
+    if ! getent passwd znc > /dev/null; then
+      sudo useradd --create-home -d /var/lib/znc --system --shell /sbin/nologin --comment "Account to run ZNC daemon" --user-group znc
+    fi
+    sudo chmod 700 /var/lib/znc
+    sudo chown -R znc:znc /var/lib/znc
+    # Avoid restarting if possible, reconnecting to irc is annoying.
+    # The unit file was made active with conflink.
+    # Note, avoid using ser here because we wrap sudo to prints the command first.
+    if [[ $(systemctl is-active znc) != active ]]; then
+      sgo znc
+    fi
     ###### stop znc setup #####
 
     end
@@ -578,10 +619,28 @@ case $codename_compat in
     # mate doesnt have wayland support yet
     pi task-gnome-desktop
     ;;
+  bionic)
+    pi gnome-core
+    # by default, it sleeps when not logged in to x/wayland and on ac power.
+    # stop that.
+    sudo -u gdm dbus-launch gsettings set org.gnome.settings-daemon.plugins.power sleep-inactive-ac-type 'nothing'
+    systemctl --user stop gvfs-daemon
+    systemctl --user disable gvfs-daemon
+    ;;
 esac
 
 
+if [[ $codename_compat == flidas ]]; then
+  # doesnt exist in newer
+  pi gnupg-doc
+fi
 
+# abrowser is not in etiona yet, abrowser version is 68,
+# abrowser won't run on a firefox profile that was on firefox
+# version 70. firefox in ubuntu is at version 70.
+# have to rm compabibility.ini to even try downgrade.
+pi firefox
+sudo update-alternatives --set x-www-browser /usr/bin/firefox
 
 # TODO: some of the X programs can be removed from pall when using wayland
 
@@ -592,11 +651,8 @@ esac
 pi ${pall[@]} $(apt-cache search ruby[.0-9]+-doc| awk '{print $1}') $(apt-cache depends gcc|grep -i suggests:| awk '{print $2}') $($src/distro-pkgs)
 
 
-sgo fsf-vpn-dns-cleanup
-
-
 # website is dead june 14 2019. back in october, but meh
-s rm -f /etc/apt/sources.list.d/iridium-browser.list
+sudo rm -fv /etc/apt/sources.list.d/iridium-browser.list
 # case $distro in
 #   debian)
 #     pi chromium ;;
@@ -639,13 +695,13 @@ s rm -f /etc/apt/sources.list.d/iridium-browser.list
 # done
 
 # key already exists, so this won't generate one, just the configs.
-vpn-server-setup -rds
-s tee -a /etc/openvpn/server/server.conf <<'EOF'
+vpn-server-setup -rds
+sudo tee -a /etc/openvpn/server/server.conf <<'EOF'
 push "dhcp-option DNS 10.0.0.1"
 push "route 10.0.0.0 255.255.0.0"
 client-connect /a/bin/distro-setup/vpn-client-connect
 EOF
-s sed -i --follow-symlinks 's/10.8./10.9./g;s/^\s*port\s.*/port 1196/' /etc/openvpn/server/server.conf
+sudo sed -i --follow-symlinks 's/10.8./10.9./g;s/^\s*port\s.*/port 1196/' /etc/openvpn/server/server.conf
 
 if [[ $HOSTNAME == tp ]]; then
   if [[ -e /lib/systemd/system/openvpn-server@.service ]]; then
@@ -661,7 +717,7 @@ fi
 ##### rss2email
 # note, see bashrc for more documentation.
 pi rss2email
-s dd of=/etc/systemd/system/rss2email.service <<'EOF'
+s/etc/systemd/system/rss2email.service <<'EOF'
 [Unit]
 Description=rss2email
 After=multi-user.target
@@ -674,7 +730,7 @@ Type=oneshot
 # we pass options to use different location.
 ExecStart=/a/bin/log-quiet/sysd-mail-once -288 rss2email r2e -d /p/c/rss2email.json -c /p/c/rss2email.cfg run
 EOF
-s dd of=/etc/systemd/system/rss2email.timer <<'EOF'
+s/etc/systemd/system/rss2email.timer <<'EOF'
 [Unit]
 Description=rss2email
 
@@ -687,12 +743,12 @@ OnUnitInactiveSec=300
 [Install]
 WantedBy=timers.target
 EOF
-s systemctl daemon-reload
+sudo systemctl daemon-reload
 
 
 ######### begin  pump.io periodic backup #############
 if [[ $HOSTNAME == frodo ]]; then
-  s dd of=/etc/systemd/system/pumpbackup.service <<'EOF'
+  s/etc/systemd/system/pumpbackup.service <<'EOF'
 [Unit]
 Description=pump li backup
 After=multi-user.target
@@ -702,7 +758,7 @@ User=iank
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once pump-backup /a/bin/distro-setup/pump-backup
 EOF
-  s dd of=/etc/systemd/system/pumpbackup.timer <<'EOF'
+  s/etc/systemd/system/pumpbackup.timer <<'EOF'
 [Unit]
 Description=pump li backup hourly
 
@@ -712,7 +768,7 @@ OnCalendar=hourly
 [Install]
 WantedBy=timers.target
 EOF
-  s systemctl daemon-reload
+  ser daemon-reload
   sgo pumpbackup.timer
 fi
 #########  end  pump.io periodic backup #############
@@ -720,7 +776,7 @@ fi
 
 ######### begin irc periodic backup #############
 if [[ $HOSTNAME == frodo ]]; then
-  s dd of=/etc/systemd/system/ircbackup.service <<'EOF'
+  s/etc/systemd/system/ircbackup.service <<'EOF'
 [Unit]
 Description=irc li backup
 After=multi-user.target
@@ -730,7 +786,7 @@ User=iank
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once irc-backup rsync -rlptDhSAX root@iankelling.org:/var/lib/znc/moddata/log/iank/freenode/ /k/irclogs
 EOF
-  s dd of=/etc/systemd/system/ircbackup.timer <<'EOF'
+  s/etc/systemd/system/ircbackup.timer <<'EOF'
 [Unit]
 Description=irc li backup hourly
 
@@ -740,7 +796,7 @@ OnCalendar=hourly
 [Install]
 WantedBy=timers.target
 EOF
-  s systemctl daemon-reload
+  sudo systemctl daemon-reload
   sgo ircbackup.timer
 fi
 
@@ -748,22 +804,13 @@ fi
 ######### end irc periodic backup #############
 
 
-# https://github.com/jlebon/textern
-cd /a/opt/textern
-make native-install USER=1
+pi-nostart openvpn
+# pi-nostart does not disable
+ser disable openvpn
 
-case $distro in
-  debian|trisquel|ubuntu)
-    # suggests resolvconf package. installing it here is redundant, but make sure anyways.
-    # todo: check other distros to make sure it\'s installed
-    pi-nostart openvpn resolvconf
-    # pi-nostart does not disable
-    ser disable openvpn
-    ;;
-  *) pi openvpn;;
-esac
+/p/c/gen-fsf-vpn
 
-/a/bin/distro-setup/radicale-setup
+/a/bin/distro-setup/radicale-setup
 
 
 ############# begin syncthing setup ###########
@@ -783,12 +830,12 @@ if [[ $HOSTNAME == frodo ]]; then
     curl -s https://syncthing.net/release-key.txt | sudo apt-key add -
     s="deb http://apt.syncthing.net/ syncthing release"
     if [[ $(cat /etc/apt/sources.list.d/syncthing.list) != "$s" ]]; then
-      echo "$s" | s dd of=/etc/apt/sources.list.d/syncthing.list
+      echo "$s" | s/etc/apt/sources.list.d/syncthing.list
       p update
     fi
   fi
   pi syncthing
-  lnf -T /w/syncthing /home/iank/.config/syncthing
+  lnf -T /w/syncthing /home/iank/.config/syncthing
   ser daemon-reload # syncthing likely not properly packaged
   sgo syncthing@iank # runs as iank
 
@@ -843,17 +890,17 @@ fi
 
 case $codename in
   flidas)
-
-  ;;
+    :
+    ;;
 esac
 
 
 # sakura config is owned by ian
-reset-sakura
-reset-konsole
-sudo -u user2 -i reset-konsole
+reset-sakura
+reset-konsole
+sudo -u user2 -i reset-konsole
 # user2 xscreensaver we don't want to reset
-reset-xscreensaver
+reset-xscreensaver
 
 
 # this would install from cabal for newer / consistent version across os, but it screws up xmonad, so disabled for now.
@@ -864,26 +911,26 @@ reset-xscreensaver
 # also, i assume syncing this between machines somehow messed thin
 #lnf -T /m/arbtt-capture.log ~/.arbtt/capture.log
 
-primary-setup
+primary-setup
 
 if [[ ! -e ~/.linphonerc && -e /p/.linphonerc-initial ]]; then
-  cp /p/.linphonerc-initial ~/.linphonerc
+  cp /p/.linphonerc-initial ~/.linphonerc
 fi
 
 
 ### begin spd install
 pi libswitch-perl libdigest-md5-file-perl libgnupg-interface-perl
 t=$(mktemp)
-wget -O $t http://mirror.fsf.org/fsfsys-trisquel/fsfsys-trisquel/pool/main/s/spd-perl/spd-perl_0.2-1_amd64.deb
-s dpkg -i $t
-rm $t
+wget -O $t http://mirror.fsf.org/fsfsys-trisquel/fsfsys-trisquel/pool/main/s/spd-perl/spd-perl_0.2-1_amd64.deb
+sudo dpkg -i $t
+rm $t
 # this guesses at the appropriate directory, adjust if needed
 perldir=(/usr/lib/x86_64-linux-gnu/perl/5.*)
-sudo ln -sf ../../../perl/5.18.2/SPD/ ${perldir[0]}
+sudo ln -sf ../../../perl/5.18.2/SPD/ ${perldir[0]}
 # newer distro had gpg2 as default, older one, flidas, need to make it that way
 gpgpath=$(which gpg2)
 if [[ $x ]]; then
-  s mkdir -p /usr/local/spdhackfix
+  sudo mkdir -p /usr/local/spdhackfix
   s lnf -T $gpgpath /usr/local/spdhackfix/gpg
 fi
 ### end spd install
@@ -956,7 +1003,7 @@ mkschroot() {
   fi
   apps=($@)
   d=/nocow/schroot/$n
-  s dd of=/etc/schroot/chroot.d/$n.conf <<EOF
+  s/etc/schroot/chroot.d/$n.conf <<EOF
 [$n]
 description=$n
 type=directory
@@ -966,18 +1013,18 @@ preserve-environment=true
 users=$USER,user2
 EOF
   if [[ -e $d/bin ]]; then
-    s chroot $d apt-get update
-    s chroot $d apt-get -y dist-upgrade --purge --auto-remove
-    cd; s schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
+    sudo chroot $d apt-get update
+    sudo chroot $d apt-get -y dist-upgrade --purge --auto-remove
+    cd; sudo schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
   else
-    s mkdir -p $d
+    sudo mkdir -p $d
 
-    s debootstrap $n $d $repo
-    cd; s schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
+    sudo debootstrap $n $d $repo
+    cd; sudo schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
   fi
-  s cp -P {,$d}/etc/localtime
+  sudo cp -P {,$d}/etc/localtime
 }
-s dd of=/etc/systemd/system/schrootupdate.service <<'EOF'
+s/etc/systemd/system/schrootupdate.service <<'EOF'
 [Unit]
 Description=schrootupdate
 After=multi-user.target
@@ -986,7 +1033,7 @@ After=multi-user.target
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once schrootupdate /a/bin/distro-setup/schrootupdate
 EOF
-s dd of=/etc/systemd/system/schrootupdate.timer <<'EOF'
+s/etc/systemd/system/schrootupdate.timer <<'EOF'
 [Unit]
 Description=schrootupdate
 
@@ -996,7 +1043,7 @@ OnCalendar=*-*-* 04:20:00
 [Install]
 WantedBy=timers.target
 EOF
-s systemctl daemon-reload
+ser daemon-reload
 sgo schrootupdate.timer
 
 
@@ -1004,39 +1051,49 @@ sgo schrootupdate.timer
 # for my roommate
 case $distro in
   trisquel)
-    mkschroot debian stretch firefox-esr pulseaudio chromium
+    # cant do buster due to old gpg
+    m mkschroot debian stretch firefox-esr pulseaudio chromium
     ;;
   debian)
     pi chromium
     ;;
 esac
 
-s mkdir -p /nocow/user
-s chown $USER:$USER /nocow/user
+sudo mkdir -p /nocow/user
+sudo chown $USER:$USER /nocow/user
 pi anki
 
 
 ####### begin transmission
 
+case $HOSTNAME in
+  frodo)
+    tdir=/i/k
+    ;;
+  *)
+    tdir=/nocow/user
+    ;;
+esac
+
 # adapted from /var/lib/dpkg/info/transmission-daemon.postinst
 # 450 seems likely to be unused. we need to specify one or else
 # it won't be stable across installs.
 if ! getent passwd debian-transmission > /dev/null; then
-  s groupadd -g 450 debian-transmission
-  s adduser --quiet \
-    --gid 450 \
-    --uid 450 \
-    --system \
-    --no-create-home \
-    --disabled-password \
-    --home /var/lib/transmission-daemon \
-    debian-transmission
+  sudo groupadd -g 450 debian-transmission
+  sudo adduser --quiet \
+       --gid 450 \
+       --uid 450 \
+       --system \
+       --no-create-home \
+       --disabled-password \
+       --home /var/lib/transmission-daemon \
+       debian-transmission
 fi
 # We want group writable stuff from transmission.
 # However, after setting this, I learn that transmission sets it's
 # own umask based on it's settings file. Well, no harm leaving this
 # so it's set right from the beginning.
-s chfn debian-transmission -o umask=0002
+sudo chfn debian-transmission -o umask=0002
 
 # note i had to do this, which is persistent:
 # cd /i/k
@@ -1049,7 +1106,7 @@ tu /etc/sysctl.conf<<'EOF'
 net.core.rmem_max = 67108864
 net.core.wmem_max = 16777216
 EOF
-s sysctl -p
+sudo sysctl -p
 
 # some reason it doesn\'t seem to start automatically anyways
 pi-nostart transmission-daemon
@@ -1062,17 +1119,17 @@ ser stop transmission-daemon
 # plus a simple symlink to the config file which it\'s
 # not worth separating out.
 # between comps, the uid can change
-f=/i/transmission-daemon
+f=$tdir/transmission-daemon
+mkdir -p $f
 s lnf -T $f /var/lib/transmission-daemon/.config/transmission-daemon
-if [[ -e $f ]]; then
-  s chown -R debian-transmission:debian-transmission $f
-fi
-for f in /i/k/partial-torrents /i/k/torrents; do
+s lnf -T /etc/transmission-daemon/settings.json $f/settings.json
+sudo chown -R debian-transmission:debian-transmission $f
+for f in $tdir/partial-torrents $tdir/torrents; do
   if [[ -e $f ]]; then
-    s chown -R debian-transmission:user2 $f
+    sudo chown -R debian-transmission:user2 $f
   fi
 done
-s chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
+sudo chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
 #
 # config file documented here, and it\'s the same config
 # for daemon vs client, so it\'s documented in the gui.
@@ -1084,16 +1141,15 @@ s chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
 #
 # Changed the cache-size to 256 mb, reduces disk use.
 # It is a read & write cache.
-#
-s ruby <<'EOF'
+sudo ruby <<EOF
 require 'json'
 p = '/etc/transmission-daemon/settings.json'
 File.write(p, JSON.pretty_generate(JSON.parse(File.read(p)).merge({
 'rpc-whitelist-enabled' => false,
 'rpc-authentication-required' => false,
-'incomplete-dir' => '/i/k/partial-torrents',
+'incomplete-dir' => '$tdir/partial-torrents',
 'incomplete-dir-enabled' => true,
-'download-dir' => '/i/k/torrents',
+'download-dir' => '$tdir/torrents',
 "speed-limit-up" => 800,
 "speed-limit-up-enabled" => true,
 "peer-port" => 61486,
@@ -1112,7 +1168,7 @@ if [[ ! -e /lib/systemd/system/openvpn-client@.service ]]; then
   vpn_ser=openvpn
 fi
 
-s dd of=/etc/systemd/system/transmission-daemon-nn.service <<EOF
+s/etc/systemd/system/transmission-daemon-nn.service <<EOF
 [Unit]
 Description=Transmission BitTorrent Daemon netns
 After=network.target
@@ -1155,7 +1211,7 @@ if [[ -e /p/transmission-rpc-pass ]]; then
 
   # the password is randomly generated on first run, i copied it out
   # so it could be used by other hosts.
-  s ruby <<'EOF'
+  sudo ruby <<'EOF'
 require 'json'
 p = '/etc/transmission-daemon/settings.json'
 s = JSON.parse(File.read(p))
@@ -1168,17 +1224,19 @@ EOF
   rpc_pass=$(</p/transmission-rpc-pass)
   for f in /home/*; do
     u=${f##*/}
-    if [[ ! $(id -u $u) -ge 1000 ]]; then
+    uid=$(id -u $u 2>/dev/null) || continue
+    if [[ ! $uid -ge 1000 ]]; then
       continue
     fi
     d=$f/.config/transmission-remote-gtk
-    s -u $u mkdir -p $d
-    s -u $u dd of=$d/config.json <<EOF
+    sudo -u $u mkdir -p $d
+    sudo -u $u dd of=$d/config.json <<EOF
 {
   "profiles" : [
-    {
+      {
       "profile-name" : "Default",
       "hostname" : "transmission.b8.nz",
+
       "rpc-url-path" : "/transmission/rpc",
       "username" : "",
       "password" : "$rpc_pass",
@@ -1192,11 +1250,28 @@ EOF
       "update-interval" : 3,
       "min-update-interval" : 3,
       "session-update-interval" : 60,
-      "exec-commands" : [
-      ],
-      "destinations" : [
-      ]
-    }
+      "exec-commands" : [],
+      "destinations" : []
+      },
+      {
+      "profile-name" : "local",
+      "hostname" : "10.173.0.2",
+
+      "username" : "",
+      "password" : "$rpc_pass",
+      "auto-connect" : true,
+      "ssl" : false,
+      "timeout" : 40,
+      "retries" : 3,
+      "update-active-only" : false,
+      "activeonly-fullsync-enabled" : false,
+      "activeonly-fullsync-every" : 2,
+      "update-interval" : 3,
+      "min-update-interval" : 3,
+      "session-update-interval" : 60,
+      "exec-commands" : [],
+      "destinations" : []
+      }
   ],
   "profile-id" : 0,
   "add-options-dialog" : false
@@ -1209,21 +1284,19 @@ fi
 
 ### printer setup
 pi cups hplip
-s gpasswd -a $USER lpadmin # based on ubuntu wiki
+sudo gpasswd -a $USER lpadmin # based on ubuntu wiki
 # goto http://127.0.0.1:631
 # administration tab, add new printer button.
 # In debian, I could use hte recommended driver,
 # in arch, I had to pick out the 6L driver.
 
 
-# allow user to run vms, from debian handbook
-for x in iank user2; do s usermod -a -G libvirt,kvm $x; done
 # bridge networking as user fails. google lead here, but it doesn\'t work:
 # oh well, I give up.
 # http://wiki.qemu.org/Features-Done/HelperNetworking
 # s mkdir /etc/qemu
 # f=/etc/qemu/bridge.conf
-# s dd of=$f <<'EOF'
+# s$f <<'EOF'
 # allow br0
 # EOF
 # #s chown root:qemu $f # debian has somethig like qemu-libvirt. equivalent?
@@ -1231,10 +1304,13 @@ for x in iank user2; do s usermod -a -G libvirt,kvm $x; done
 
 # general known for debian/ubuntu, not for fedora
 
-/a/bin/buildscripts/go
+m /a/bin/buildscripts/go
+m /a/bin/buildscripts/rust
+m /a/bin/buildscripts/misc
 
 pi-nostart virtinst virt-manager
-
+# allow user to run vms, from debian handbook
+for x in iank user2; do s usermod -a -G libvirt,kvm $x; done
 
 
 pi --no-install-recommends kdeconnect
@@ -1263,7 +1339,7 @@ sudo adduser $USER dialout
 # this is for the mail command too. update-alternatives is kind of misleading
 # since at least it's main commands pretend mail does not exist.
 # bsd's mail got pulled in on some dumb dependency, i dunno how.
-s update-alternatives --set mailx /usr/bin/mail.mailutils
+sudo update-alternatives --set mailx /usr/bin/mail.mailutils
 
 ######### end misc packages #########
 
@@ -1288,7 +1364,7 @@ pi smartmontools
 # -o on, turn on 4 hour period non-performance degrading testing.
 # short test daily 2-3am, extended tests Saturdays between 3-4am:
 sched="-s (S/../.././02|L/../../6/03)"
-s sed -i --follow-symlinks "s#^[[:space:]]*DEVICESCAN.*#\
+sudo sed -i --follow-symlinks "s#^[[:space:]]*DEVICESCAN.*#\
 DEVICESCAN -a -o on -S on -n standby,q $sched \
 -m ian@iankelling.org -M exec /usr/local/bin/smart-notify#" /etc/smartd.conf
 
@@ -1308,21 +1384,39 @@ DEVICESCAN -a -o on -S on -n standby,q $sched \
 
 ########### misc stuff
 
-# make networkmanager use resolvconf instead of its own dnsmasq which
-# conflicts with the normal dnsmasq package.
-f=/etc/NetworkManager/NetworkManager.conf
-m=$(md5sum $f)
-s sed -ri '/ *\[main\]/,/^ *\[[^]]+\]/{/^\s*dns[[:space:]=]/d}' $f
-if [[ $m != $(md5sum $f) ]]; then
-  srestart NetworkManager
-fi
+case $(debian-codename) in
+  # needed for debootstrap scripts for fai since fai requires debian
+  flidas)
+    pi dnsmasq
+    pi-nostart network-manager
+    # make networkmanager use resolvconf instead of its own dnsmasq which
+    # conflicts with the normal dnsmasq package.
+    f=/etc/NetworkManager/NetworkManager.conf
+    m=$(md5sum $f)
+    sudo sed -ri '/ *\[main\]/,/^ *\[[^]]+\]/{/^\s*dns[[:space:]=]/d}' $f
+    sudo sed -ri '/ *\[main\]/a dns=default' $f
+    if [[ $m != $(md5sum $f) ]]; then
+      srestart NetworkManager
+    fi
+    # networkmanager has this nasty behavior on flidas: if the machine
+    # crashes with dnsmasq running, on subsequent boot, it adds an entry to
+    # resolvconf for 127.0.0.1 in some stupid attempt to restore
+    # nameservers.
+    # This can be manually fixed by stoping dnsmasq,
+    # then based on whats in /run/dnsmasq/, i see we can run
+    # s resolvconf -d NetworkManager
+    # oh ya, and stoping NetworkManager leaves this crap behind without cleaning it up.
+    ser disable NetworkManager
+    ;;
+esac
 
 # make my /etc/fonts/conf.d/ get used.
 # I have a new sans-serif font there because the default one
 # displays l and I as the same char, grrrrr.
-s fc-cache
+sudo fc-cache
 
-/a/bin/distro-setup/mymimes
+pi desktop-file-utils
+m /a/bin/distro-setup/mymimes
 
 
 sgo dynamicipupdate
@@ -1332,7 +1426,7 @@ sgo dynamicipupdate
 # dbus-launch makes this work within an ssh connection, otherwise you get this message,
 # with still 0 exit code.
 # dconf-WARNING **: failed to commit changes to dconf: Cannot autolaunch D-Bus without X11 $DISPLAY
-dbus-launch gsettings set org.gnome.desktop.media-handling automount-open false
+dbus-launch gsettings set org.gnome.desktop.media-handling automount-open false
 
 
 # on grub upgrade, we get prompts unless we do this
@@ -1341,7 +1435,7 @@ for dev in $(s btrfs fil show /boot | sed -nr 's#.*path\s+(\S+)$#\1#p'); do
   devs+=("$(devbyid $dev),")
 done
 devs[-1]=${devs[-1]%,} # jonied by commas
-s debconf-set-selections <<EOF
+sudo debconf-set-selections <<EOF
 grub-pc grub-pc/install_devices multiselect ${devs[*]}
 EOF
 
@@ -1350,8 +1444,8 @@ sgo btrfsmaint.timer
 sgo btrfsmaintstop.timer
 
 # aren't autoupdating this, but I do check on it somewhat regularly.
-cd /a/opt/btrbk
-s make install
+cd /a/opt/btrbk
+sudo make install
 
 sgo btrbk.timer
 # note: to see when it was last run,
@@ -1363,17 +1457,11 @@ In mate settings settings, change scrolling to two-finger,
 because the default edge scroll doesn\'t work. Originally found this in debian.
 EOF
 
-case $distro in
-  debian)
-    # remove dep that came in with desktop
-    pu transmission-gtk
-    ;;
-esac
-
+# Remove dep that came in with desktop to fix associations.
+m pu transmission-gtk
 
-s gpasswd -a iank adm ;; #needed for reading logs
 
-/a/bin/buildscripts/pithosfly
+/a/bin/buildscripts/pithosfly
 
 
 # # Based on guix manual instructions, also added code to profile.
@@ -1394,21 +1482,11 @@ s gpasswd -a iank adm ;; #needed for reading logs
 
 
 pi tor
-/a/bin/buildscripts/tor-browser
+/a/bin/buildscripts/tor-browser
 
 # nfs server
-pi-nostart nfs-server
+pi-nostart nfs-kernel-server
 
-# networkmanager has this nasty behavior on flidas: if the machine
-# crashes with dnsmasq running, on subsequent boot, it adds an entry to
-# resolvconf for 127.0.0.1 in some stupid attempt to restore
-# nameservers.
-# This can be manually fixed by stoping dnsmasq,
-# then based on whats in /run/dnsmasq/, i see we can run
-# s resolvconf -d NetworkManager
-# oh ya, and stoping NetworkManager leaves this crap behind without cleaning it up.
-ser stop NetworkManager
-ser disable NetworkManager
 
 
 if [[ $HOSTNAME == frodo ]]; then
@@ -1420,7 +1498,7 @@ if [[ $HOSTNAME == frodo ]]; then
   tu /etc/exports <<'EOF'
 /k 10.0.0.0/24(rw,fsid=0,nohide,no_root_squash,async,no_subtree_check,insecure)
 EOF
-  s exportfs -rav
+  sudo exportfs -rav
 fi